local NAME, NS = ...
NS.data = {} local DATA = NS.data
local addon,DB = CreateFrame("Frame")
local delay_queue,combat_queue = {},{}
local UUID = "3FDC4CB045FF4438B06AFB7BCB0CA2EC"
local next,pairs,wipe,tinsert,tremove,tContains =
	  next,pairs,wipe,tinsert,tremove,tContains
local GetActiveSpecGroup,GetTalentInfo,GetActionInfo,HasAction,GetNumMacros,GetMacroBody,GetMacroInfo = 
	  GetActiveSpecGroup,GetTalentInfo,GetActionInfo,HasAction,GetNumMacros,GetMacroBody,GetMacroInfo
local IsPassiveSpell,PickupAction,PickupSpell,ClearCursor = 
	  IsPassiveSpell,PickupAction,PickupSpell,ClearCursor
-- utility
local tempname = ("%sDump"):format(NAME)
local label = ("|cffCC9933%s:|r %%s"):format(NAME)
addon.debug = function(object)
	UIParentLoadAddOn("Blizzard_DebugTools")
	_G[tempname] = object
	DevTools_DumpCommand(tempname)
	_G[tempname] = nil
end
addon.Print = function(msg)
	local output = string.format(label,msg)
	if DEFAULT_CHAT_FRAME and output then
		DEFAULT_CHAT_FRAME:AddMessage(output)
		if not DEFAULT_CHAT_FRAME:IsVisible() then
			FCF_SelectDockFrame(DEFAULT_CHAT_FRAME)
		end
	end
end
addon.Slasher = function(cmd)
	cmd = cmd or ""
	local cmdl = strlower(cmd)
	if cmdl == "macros" then
		DB.macros = not DB.macros
		addon.Print("Automatic Macro Replacement - "..(DB.macros and "ON" or "OFF"))
		addon.PLAYER_TALENT_UPDATE()
	elseif cmdl == "actions" then
		DB.actions = not DB.actions
		addon.Print("Automatic ActionButton Replacement - "..(DB.actions and "ON" or "OFF"))
		addon.PLAYER_TALENT_UPDATE()
	elseif cmdl == "doactions" then
		addon.useraction = "actions"
		tinsert(delay_queue,addon.ActionReplace)
		addon.RunAfter(1.0,true)
		addon.Print("Running queued actionbutton replacements (out of combat)")
	elseif cmdl == "domacros" then
		addon.useraction = "macros"
		tinsert(delay_queue,addon.MacroReplace)
		addon.RunAfter(1.0,true)
		addon.Print("Running queued macro replacements (out of combat)")
	else
		addon.Print("\n/talentswap actions\n     toggles automatic actionbutton replacements\n/talentswap macros\n     toggles automatic macro replacements\n/talentswap doactions\n     does a manual actionbutton replacement\n/talentswap domacros\n     does a manual macro replacement")
	end
end
local escape = function(text)
	return (text:gsub("[%(%)%.%%%+%-%*%?%[%]%^%$]", "%%%0"))
end
local Counter = CreateFrame("EditBox")
Counter:SetAutoFocus(false)
Counter:SetMultiLine(true)
Counter:SetCountInvisibleLetters(true)
Counter:SetMaxLetters(0)
local lettercount = function(text)
	Counter:SetText(text)
	return Counter:GetNumLetters() or 0
end
-- event handling
addon.OnEvent = function(self,event,...)
	return self[event] and self[event](...)
end
addon:SetScript("OnEvent",addon.OnEvent)
-- delayed execution
addon.OnFinished = function(self,requested)
	while next(delay_queue) do
		if addon.nocombat then
			addon.CombatCheck(tremove(delay_queue, 1))
		else
			tremove(delay_queue, 1)()
		end
	end
end
addon.ag = addon:CreateAnimationGroup()
addon.ag:SetLooping("NONE")
addon.ag.timer = addon.ag:CreateAnimation("Animation")
addon.timer = addon.ag.timer
addon.timer:SetScript("OnFinished",addon.OnFinished)
addon.RunAfter = function(seconds,nocombat)
	addon.nocombat = nocombat
	if not addon.ag:IsPlaying() then
		addon.timer:SetDuration(seconds)
		addon.ag:Play()
	end
end
-- combat queue: FIFO
addon.PLAYER_REGEN_ENABLED = function()
	while next(combat_queue) do
		tremove(combat_queue, 1)()
	end
	addon:UnregisterEvent("PLAYER_REGEN_ENABLED")
end
addon.CombatCheck = function(func)
	if InCombatLockdown() or UnitAffectingCombat("player") then
		if not tContains(combat_queue,func) then 
			tinsert(combat_queue,func)
			addon:RegisterEvent("PLAYER_REGEN_ENABLED")
		end
	else
		func()
	end
end
-- Scanners
addon.scanTip = CreateFrame("GameTooltip",("tip%s"):format(UUID),nil,"GameTooltipTemplate")
addon.scanTip:SetOwner(UIParent,"ANCHOR_NONE")
DATA["specialization"] = {}
for i=0,MAX_TALENT_GROUPS do
	DATA["specialization"][i] = {}
	DATA["specialization"][i]["talents"] = {}
	DATA["specialization"][i]["talents"]["active"] = {}
	DATA["specialization"][i]["talents"]["inactive"] = {}
end
addon.TalentScan = function()
	local specid = GetActiveSpecGroup() or 0
	local active = wipe(DATA["specialization"][specid]["talents"]["active"])
	local inactive = wipe(DATA["specialization"][specid]["talents"]["inactive"])
	for talent_id=1, MAX_NUM_TALENTS do
		local name, iconTexture, tier, column, selected, available = GetTalentInfo(talent_id)
		if (name) then
			addon.scanTip:SetTalent(talent_id)
			local _,_,spellid = addon.scanTip:GetSpell()
			if spellid then
				if selected then
					if not IsPassiveSpell(spellid) then
						active[tier] = {["name"]=name,["spellid"]=spellid}
					else
						inactive[spellid] = {["name"]=name,["tier"]=tier}
					end
				else
					inactive[spellid] = {["name"]=name,["tier"]=tier}
				end
			end
		end
	end
end
DATA["pending"] = {}
DATA["pending"]["buttons"] = {}
addon.ActionbarScan = function()
	local specid = GetActiveSpecGroup() or 0
	local active = DATA["specialization"][specid]["talents"]["active"]
	local inactive = DATA["specialization"][specid]["talents"]["inactive"]
	local previous = DB["specialization"][specid]
	local pending = wipe(DATA["pending"]["buttons"])
	for button=1,120 do
		local actionType, id, subType = GetActionInfo(button)
		if actionType == "spell" then
			if inactive[id] then
				local tier = inactive[id]["tier"]
				if active[tier] then
					pending[button] = active[tier]["spellid"]
				else
					pending[button] = 0
				end
			end
		end
		if not HasAction(button) then
			local tier = previous[button]
			if tier and active[tier] then
				pending[button] = active[tier]["spellid"]
			end
		end
	end
end
DATA["pending"]["macros"] = {}
addon.MacroScan = function()
	local specid = GetActiveSpecGroup() or 0
	local pending = wipe(DATA["pending"]["macros"])
	local active = DATA["specialization"][specid]["talents"]["active"]
	local inactive = DATA["specialization"][specid]["talents"]["inactive"]
	local global,char = GetNumMacros()
	local MAX_ACCOUNT_MACROS = MAX_ACCOUNT_MACROS or 36
	local globaloffset,charoffset = 1,MAX_ACCOUNT_MACROS+1
	if char > 0 then
		for macroid = charoffset, charoffset+char-1 do
			local body = GetMacroBody(macroid)
			for id,data in pairs(inactive) do
				if body:find(data["name"],1,true) then
					pending[macroid] = true
					break
				end
			end
		end
	end
	if global > 0 then
		for macroid = globaloffset, global do
			local body = GetMacroBody(macroid)
			for id,data in pairs(inactive) do
				if body:find(data["name"],1,true) then
					pending[macroid] = true
					break
				end
			end
		end
	end
end
-- Updaters
addon.ActionReplace = function()
	if not (DB.actions or addon.useraction) then return end
	addon.useraction = nil
	local specid = GetActiveSpecGroup() or 0
	local pending = DATA["pending"]["buttons"]
	local inactive = DATA["specialization"][specid]["talents"]["inactive"]
	local previous = DB["specialization"][specid]
	if not next(pending) then return end
	for button,spell in pairs(pending) do
		if spell == 0 then
			if HasAction(button) then
				local actionType, id, subType = GetActionInfo(button)
				if actionType == "spell" and inactive[id] then
					previous[button] = inactive[id]["tier"]
				end
			end
			ClearCursor()
			PickupAction(button)
			ClearCursor()
		else
			ClearCursor()
			PickupSpell(spell)
			PickupAction(button)
			ClearCursor()
			if HasAction(button) and previous[button] then previous[button] = nil end
		end
	end
	wipe(pending)
end
local MACRO_LIMIT = tonumber((_G.MACROFRAME_CHAR_LIMIT):match("%d+"))
addon.MacroReplace = function()
	if not (DB.macros or addon.useraction) then return end
	addon.useraction = nil
	local specid = GetActiveSpecGroup() or 0
	local pending = DATA["pending"]["macros"]
	local active = DATA["specialization"][specid]["talents"]["active"]
	local inactive = DATA["specialization"][specid]["talents"]["inactive"]
	if not next(pending) then return end
	for macroid,_ in pairs(pending) do
		local body = GetMacroBody(macroid)
		local old,new
		local modified,changes
		for id,data in pairs(inactive) do
			old = data["name"]
			new = active[data["tier"]] and active[data["tier"]]["name"]
			if old and new then
				body,changes = body:gsub(escape(old),new)
				if changes > 0 then modified = true end
			end
		end
		local bodylen = lettercount(body)
		if modified and bodylen <= MACRO_LIMIT then
			EditMacro(macroid,nil,nil,body)
			if MacroFrame and MacroFrame:IsVisible() and MacroFrame.selectedMacro == macroid then
				MacroFrameText:SetText(body)
				MacroFrame_Update()
			end
		elseif bodylen > MACRO_LIMIT then
			local name = strtrim((GetMacroInfo(macroid)))
			local out = ("Macro %d:%s not updated due to exceeding char limit"):format(macroid,name)
			addon.debug(out)
		end
	end
	wipe(pending)
end
-- Events
addon.PLAYER_TALENT_UPDATE = function()
	tinsert(delay_queue,addon.TalentScan)
	tinsert(delay_queue,addon.ActionbarScan)
	tinsert(delay_queue,addon.MacroScan)
	tinsert(delay_queue,addon.ActionReplace)
	tinsert(delay_queue,addon.MacroReplace)
	addon.RunAfter(2.0,true)
end
addon.UPDATE_MACROS = function()
	tinsert(delay_queue,addon.MacroScan)
	addon.RunAfter(1.0,true)
end
-- initialization
local defaults = {actions=true,macros=true,specialization={}}
for i=0,MAX_TALENT_GROUPS do
	defaults["specialization"][i] = {}
end
local events = {"PLAYER_TALENT_UPDATE","UPDATE_MACROS"}
addon:RegisterEvent("ADDON_LOADED")
addon.ADDON_LOADED = function(addonName)
	if addonName == NAME then
		if IsLoggedIn() then
			addon.PLAYER_LOGIN()
		else
			addon:RegisterEvent("PLAYER_LOGIN")
		end
		addon:UnregisterEvent("ADDON_LOADED")
	end
end
addon.PLAYER_LOGIN = function()
	TalentSwapDB = TalentSwapDB or CopyTable(defaults)
	if not TalentSwapDB["specialization"] then
		TalentSwapDB = CopyTable(defaults)
	end
	DB = TalentSwapDB
	-- option panel: TODO
	SlashCmdList["TALENTSWAP"] = addon.Slasher
	SLASH_TALENTSWAP1 = "/talentswap"
	SLASH_TALENTSWAP2 = "/tswap"
	tinsert(delay_queue,addon.TalentScan)
	tinsert(delay_queue,addon.ActionbarScan)
	tinsert(delay_queue,addon.MacroScan)
	tinsert(delay_queue,addon.StartEvents)
	addon.RunAfter(5.0,true)
end
addon.StartEvents = function()
	for _,event in ipairs(events) do
		addon:RegisterEvent(event)
	end
end
_G[NAME] = addon